from ophelian._logger import OphelianLogger


class OphelianInfo:

    def __init__(self):
        self.__logger = OphelianLogger()
        self.__version = "ophelian.0.1.3"
        self.__info = {
            "welcome": "Welcome to 'Ophelian On Mars', more than a Framework.",
            "version": f"Package Version {self.__version}",
        }

    def __auto_space(self, msg):
        max_info = self.__info[max(self.__info)]
        default_tape = "█ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █"
        if len(default_tape) > len(max_info):
            space = " " * (abs(len(default_tape) - len(msg)))
            return msg + space
        elif len(default_tape) < len(max_info):
            space = " " * (abs(len(max_info) - len(msg)))
            return msg + space

    def __build_info(self):
        self.__logger.tape(self.__info[max(self.__info)], adjust_tape=-2)
        for i in self.__info.keys():
            if i != "warn":
                self.__logger.info("| " + self.__auto_space(self.__info[i]) + " |")
            else:
                self.__logger.warning("| " + self.__auto_space(self.__info[i]) + " |")
        self.__logger.tape(self.__info[max(self.__info)], adjust_tape=-2)

    def __build_mask(self):
        self.__logger.warning(
            self.__auto_space(
                "                     - Ophelian On Mars -                      "
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ █ █ █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █ █ █ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ ╬ ╬ ╬ █ █ █ █ █ █ █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █ █ █ █ █ █ █ ╬ ╬ ╬ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ ╬ ╬ █ █ ╬ ╬ ╬ ╬ █ █ █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █ █ █ ╬ ╬ ╬ ╬ █ █ ╬ ╬ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ ╬ █ █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █ █ ╬ ╬ ╬ ╬ ╬ █ █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █ █ ╬ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ ╬ ╬ ╬ ╬ █ █ █ █ █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █ █ █ █ █ ╬ ╬ ╬ ╬ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ ╬ ╬ █ █ █ █ █ █ █ █ █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █ █ █ █ █ █ █ █ █ ╬ ╬ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ ╬ ╬ ╬ ▓ ▓ ▓ ▓ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ▓ ▓ ▓ ▓ ╬ ╬ ╬ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ ╬ ╬ ▓ ▓ ▓ ▓ ▓ ▓ ╬ ╬ █ ╬ ╬ ╬ █ ╬ ╬ ╬ █ ╬ ╬ ▓ ▓ ▓ ▓ ▓ ▓ ╬ ╬ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ ╬ ╬ ╬ ▓ ▓ ▓ ▓ ╬ ╬ █ █ ╬ ╬ ╬ █ ╬ ╬ ╬ █ █ ╬ ╬ ▓ ▓ ▓ ▓ ╬ ╬ ╬ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █ █ ╬ ╬ ╬ ╬ █ ╬ ╬ ╬ ╬ █ █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ ╬ ╬ ╬ ╬ ╬ █ █ █ █ ╬ ╬ ╬ ╬ █ █ █ ╬ ╬ ╬ ╬ █ █ █ █ ╬ ╬ ╬ ╬ ╬ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █ █ █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ █ ╬ ╬ █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █ █ █ █ █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █ ╬ ╬ █ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ █ ╬ ╬ █ █ ╬ ╬ ╬ ╬ ╬ ╬ █ █ █ █ █ █ █ ╬ ╬ ╬ ╬ ╬ ╬ █ █ ╬ ╬ █ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ █ ╬ ╬ ▓ █ █ █ ╬ ╬ ╬ █ █ █ █ ╬ █ █ █ █ ╬ ╬ ╬ █ █ █ ▓ ╬ ╬ █ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ █ █ ╬ ╬ ▓ ▓ █ █ █ █ █ █ █ ╬ ╬ ╬ █ █ █ █ █ █ █ ▓ ▓ ╬ ╬ █ █ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ █ █ ╬ ╬ ╬ ╬ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ╬ ╬ ╬ ╬ █ █ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ █ █ █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █ █ █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █ █ █ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ █ █ █ █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █ █ █ █ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ █ █ █ █ █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █ █ █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █ █ █ █ █ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ █ █ █ █ █ █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █ █ █ ╬ ╬ ╬ ╬ ╬ ╬ ╬ █ █ █ █ █ █ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ █ █ █ █ █ █ █ ╬ ╬ ╬ ╬ ╬ ╬ █ █ █ ╬ ╬ ╬ ╬ ╬ ╬ █ █ █ █ █ █ █ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ █ █ █ █ █ █ █ █ ╬ ╬ ╬ ╬ ╬ █ █ █ ╬ ╬ ╬ ╬ ╬ █ █ █ █ █ █ █ █ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ █ █ █ █ █ █ █ █ █ █ ╬ ╬ ╬ ╬ █ ╬ ╬ ╬ ╬ █ █ █ █ █ █ █ █ █ █ █"
            )
        )
        self.__logger.mask(
            self.__auto_space(
                "  █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █ █\n"
            )
        )

    def __build_ophelian_message(self):
        self.__build_info()
        self.__build_mask()

    def print_info(self, mask):
        if mask:
            return self.__build_ophelian_message()
        return self.__build_info()
